AbstractTypeMaterializer.Feature (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.mrbean

## Enum AbstractTypeMaterializer.Feature

- java.lang.Object
- - java.lang.Enum<AbstractTypeMaterializer.Feature>
  - - org.codehaus.jackson.mrbean.AbstractTypeMaterializer.Feature

- All Implemented Interfaces:
    Serializable, Comparable<AbstractTypeMaterializer.Feature>
  Enclosing class:
    AbstractTypeMaterializer

      public static enum AbstractTypeMaterializer.Feature
      extends Enum<AbstractTypeMaterializer.Feature>

  Enumeration that defines togglable features that guide the serialization feature.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `FAIL_ON_NON_PUBLIC_TYPES` Feature that determines what happens when attempt is made to generate implementation of non-public class or interface.
    `FAIL_ON_UNMATERIALIZED_METHOD` Feature that determines what happens if an "unrecognized" (non-getter, non-setter) abstract method is encountered: if set to true, will throw an exception during materialization; if false, will materialize method that throws exception only if called.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static int` | `collectDefaults()`
    `boolean` | `enabledByDefault()`
    `int` | `getMask()`
    `static AbstractTypeMaterializer.Feature` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static AbstractTypeMaterializer.Feature[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### FAIL_ON_UNMATERIALIZED_METHOD

          public static final AbstractTypeMaterializer.Feature FAIL_ON_UNMATERIALIZED_METHOD

      Feature that determines what happens if an "unrecognized" (non-getter, non-setter) abstract method is encountered: if set to true, will throw an exception during materialization; if false, will materialize method that throws exception only if called.

    - #### FAIL_ON_NON_PUBLIC_TYPES

          public static final AbstractTypeMaterializer.Feature FAIL_ON_NON_PUBLIC_TYPES

      Feature that determines what happens when attempt is made to generate implementation of non-public class or interface. If true, an exception is thrown; if false, will just quietly ignore attempts.
      Since:
        1.9

  - ### Method Detail

    - #### values

          public static AbstractTypeMaterializer.Feature[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (AbstractTypeMaterializer.Feature c : AbstractTypeMaterializer.Feature.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static AbstractTypeMaterializer.Feature valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### collectDefaults

          protected static int collectDefaults()

    - #### enabledByDefault

          public boolean enabledByDefault()

    - #### getMask

          public int getMask()